import request from '@/utils/request'

// 应用列表
export function listApp(data) {
  return request({
    url: '/system/app/listApp',
    method: 'get',
    params: data
  })
}

// 新增
export function insertApp(data) {
  return request({
    url: '/system/app/insertApp',
    method: 'post',
    data
  })
}

// 修改
export function updateApp(data) {
  return request({
    url: '/system/app/updateApp',
    method: 'post',
    data: data
  })
}

// 回显
export function selectApp(data) {
  return request({
    url: '/system/app/selectApp',
    method: 'post',
    data: data
  })
}

// 状态修改
export function changeStatus(id, status) {
  const data = {
    id,
    status
  }
  return request({
    url: '/system/app/changeStatus',
    method: 'post',
    data
  })
}

// 批量删除
export function deleteApp (code) {
  return request({
    url: '/system/app/deleteApp/' + code,
    method: 'delete'
  })
}
