import request from '@/utils/request'

// 应用列表
export function listApp(data) {
  return request({
    url: '/hzArea/areaList',
    method: 'get',
    params: data
  })
}

// 获取区域树
export function areaTree(data) {
  return request({
    url: '/hzArea/areaTree?' + data,
    method: 'get'
  })
}

// 新增
export function insertApp(data) {
  return request({
    url: '/hzArea/saveArea',
    method: 'post',
    data
  })
}

// 修改
export function updateApp(data) {
  return request({
    url: '/hzArea/getArea',
    method: 'post',
    data: data
  })
}

// 回显
export function selectApp(data) {
  return request({
    url: '/hzArea/getArea',
    method: 'get',
    data: data
  })
}

// 批量删除
export function deleteApp (code) {
  return request({
    url: '/hzArea/deleteArea/' + code,
    method: 'delete'
  })
}

// 保存地区树
export function saveAreaRegion (data) {
  return request({
    url: '/hzArea/saveAreaRegion',
    method: 'post',
    data: data
  })
}

// 废弃
export function discardApp (data) {
  return request({
    url: '/hzArea/abolishArea?' + data,
    method: 'get',
    data: data
  })
}

//获取大区
export function selectAreaApp(data) {
  return request({
    url: '/hzArea/bigAreaList',
    method: 'get',
    data: data
  })
}
