import request from '@/utils/request'

// 查询资源列表
export function listResource(data) {
  return request({
    url: '/system/resource/listResource',
    method: 'get',
    params: data
  })
}

// 新增资源
export function insertResource(data) {
  return request({
    url: '/system/resource/insertResource',
    method: 'post',
    data: data
  })
}

// 更新资源
export function updateResource(data) {
  return request({
    url: '/system/resource/updateResource',
    method: 'post',
    data: data
  })
}

// 回显资源
export function selectResource(data) {
  return request({
    url: '/system/resource/selectResource',
    method: 'post',
    data: data
  })
}

// 状态修改
export function changeStatus(id, status) {
  const data = {
    id,
    status
  }
  return request({
    url: '/system/resource/changeStatus',
    method: 'post',
    data
  })
}

// 删除资源
export function deleteResource (data) {
  return request({
    url: '/system/resource/deleteResource',
    method: 'post',
    data
  })
}

// 批量删除资源
export function batchDelete (code) {
  return request({
    url: '/system/resource/batchDelete/' + code,
    method: 'delete'
  })
}

// 所属应用
export function applicationList (data) {
  return request({
    url: '/system/resource/applicationList',
    method: 'post',
    data: {
      ...data,
      status: '0'
    }
  })
}

// 业务单元
export function applicationListUnit () {
  return request({
    url: '/hzArea/role/getAllBusinessUnit',
    method: 'get'
  })
}

// 已绑定列表
export function findbindRes (data) {
  return request({
    url: '/system/resource/findbindRes',
    method: 'get',
    params: data
  })
}

// 未绑定列表
export function findUnbindRes (data) {
  return request({
    url: '/system/resource/findUnbindRes',
    method: 'get',
    params: data
  })
}

// 资源数据权限列表
export function findByRole (data) {
  return request({
    url: '/system/resource/findByRole',
    method: 'get',
    params: data
  })
}
