import request from '@/utils/request'

// 获取所有特殊角色类型和人数
export function listRole (query) {
  return request({
    url: '/hzArea/specialRole/getSpecialRoleNums',
    method: 'get',
    params: query
  })
}

// 查询角色详细
export function getRole (roleId) {
  return request({
    url: '/hzArea/role/' + roleId,
    method: 'get'
  })
}

// 新增角色
export function addRole (data) {
  return request({
    url: '/hzArea/role',
    method: 'post',
    data: data
  })
}

// 查询所有特殊角色列表
export function getSpecialRole (roleId) {
  return request({
    url: '/hzArea/specialRole/list?majorDirectionCode=' + roleId,
    method: 'get'
  })
}

// 修改角色
export function updateRole (data) {
  return request({
    url: '/hzArea/role',
    method: 'put',
    data: data
  })
}

// 角色数据权限
export function dataScope (data) {
  return request({
    url: '/system/role/dataScope',
    method: 'put',
    data: data
  })
}

// 角色状态修改
export function changeRoleStatus (roleId, status) {
  const data = {
    roleId,
    status
  }
  return request({
    url: '/system/role/changeStatus',
    method: 'put',
    data: data
  })
}

// 删除角色
export function delRole (roleId) {
  return request({
    url: '/hzArea/role/' + roleId,
    method: 'delete'
  })
}

// 查询用户
export function getDataRole (data) {
  return request({
    url: '/otherapi/getData/empl?text=' + data +'&currentPageNo=1',
    method: 'get'
  })
}

// 查找所有子角色
export function childRoleList (data) {
  return request({
    url: '/system/role/childRoleList',
    method: 'post',
    data
  })
}

// 批量保存
export function saveBatchRoleList (data) {
  return request({
    url: '/hzArea/specialRole/saveBatch',
    method: 'post',
    data
  })
}
