import { constantRoutes } from "@/router";
import { getRouters } from "@/api/menu";
import Layout from "@/layout/index";

const permission = {
  state: {
    routes: [],
    addRoutes: [],
  },
  mutations: {
    SET_ROUTES: (state, routes) => {
      console.log(state, routes, "routes");
      state.addRoutes = routes;
      state.routes = constantRoutes.concat(routes);
      console.log(state, "state");
    },
  },
  actions: {
    // 生成路由
    GenerateRoutes({ commit }) {
      return new Promise((resolve) => {
        // 向后端请求路由数据
        getRouters().then((res) => {
          console.log(res, "res");
          const filter = res.data.filter((item) => item.name === "-9999");
          let arr = [
            {
              name: "System",
              path: "system",
              hidden: false,
              redirect: "noRedirect",
              component: "Layout",
              alwaysShow: true,
              meta: {
                title: "系统管理",
                icon: "system",
              },
              children: [
                {
                  name: "User",
                  path: "user",
                  hidden: false,
                  component: "system/user/index",
                  meta: {
                    title: "用户管理",
                    icon: "user",
                  },
                },
                {
                  name: "Role",
                  path: "role",
                  hidden: false,
                  component: "system/role/index",
                  meta: {
                    title: "角色管理",
                    icon: "peoples",
                  },
                },
                {
                  name: "Menu",
                  path: "menu",
                  hidden: false,
                  component: "system/menu/index",
                  meta: {
                    title: "菜单管理",
                    icon: "tree-table",
                  },
                },
                {
                  name: "Dept",
                  path: "dept",
                  hidden: false,
                  component: "system/dept/index",
                  meta: {
                    title: "部门管理",
                    icon: "tree",
                  },
                },
                {
                  name: "Post",
                  path: "post",
                  hidden: false,
                  component: "system/post/index",
                  meta: {
                    title: "岗位管理",
                    icon: "post",
                  },
                },
                {
                  name: "Dict",
                  path: "dict",
                  hidden: false,
                  component: "system/dict/index",
                  meta: {
                    title: "字典管理",
                    icon: "dict",
                  },
                },
                {
                  name: "Config",
                  path: "config",
                  hidden: false,
                  component: "system/config/index",
                  meta: {
                    title: "参数设置",
                    icon: "edit",
                  },
                },
                {
                  name: "Notice",
                  path: "notice",
                  hidden: false,
                  component: "system/notice/index",
                  meta: {
                    title: "通知公告",
                    icon: "message",
                  },
                },
                {
                  name: "Log",
                  path: "log",
                  hidden: false,
                  redirect: "noRedirect",
                  component: "system/log/index",
                  alwaysShow: true,
                  meta: {
                    title: "日志管理",
                    icon: "log",
                  },
                  children: [
                    {
                      name: "Operlog",
                      path: "operlog",
                      hidden: false,
                      component: "monitor/operlog/index",
                      meta: {
                        title: "操作日志",
                        icon: "form",
                      },
                    },
                    {
                      name: "Logininfor",
                      path: "logininfor",
                      hidden: false,
                      component: "monitor/logininfor/index",
                      meta: {
                        title: "登录日志",
                        icon: "logininfor",
                      },
                    },
                  ],
                },
              ],
            },
            {
              name: "Monitor",
              path: "/monitor",
              hidden: false,
              redirect: "noRedirect",
              component: "Layout",
              alwaysShow: true,
              meta: {
                title: "系统监控",
                icon: "monitor",
              },
              children: [
                {
                  name: "Online",
                  path: "online",
                  hidden: false,
                  component: "monitor/online/index",
                  meta: {
                    title: "在线用户",
                    icon: "online",
                  },
                },
                {
                  name: "Job",
                  path: "job",
                  hidden: false,
                  component: "monitor/job/index",
                  meta: {
                    title: "定时任务",
                    icon: "job",
                  },
                },
                {
                  name: "Druid",
                  path: "druid",
                  hidden: false,
                  component: "monitor/druid/index",
                  meta: {
                    title: "数据监控",
                    icon: "druid",
                  },
                },
                {
                  name: "Server",
                  path: "server",
                  hidden: false,
                  component: "monitor/server/index",
                  meta: {
                    title: "服务监控",
                    icon: "server",
                  },
                },
              ],
            },
            {
              name: "Tool",
              path: "/tool",
              hidden: false,
              redirect: "noRedirect",
              component: "Layout",
              alwaysShow: true,
              meta: {
                title: "系统工具",
                icon: "tool",
              },
              children: [
                {
                  name: "Build",
                  path: "build",
                  hidden: false,
                  component: "tool/build/index",
                  meta: {
                    title: "表单构建",
                    icon: "build",
                  },
                },
                {
                  name: "Gen",
                  path: "gen",
                  hidden: false,
                  component: "tool/gen/index",
                  meta: {
                    title: "代码生成",
                    icon: "code",
                  },
                },
                {
                  name: "Swagger",
                  path: "swagger",
                  hidden: false,
                  component: "tool/swagger/index",
                  meta: {
                    title: "系统接口",
                    icon: "swagger",
                  },
                },
              ],
            },
          ];
          let routes = (filter[0] && filter[0].children) || [];
          arr.forEach((item) => {
            item.path = `/${item.path}`;
          });
          // routes[0].children.splice(3, 0, {
          //     name: 'Resource',
          //     path: 'resource',
          //     hidden: false,
          //     component: 'system/resource/index',
          //     meta: {
          //       title: '资源管理',
          //       icon: 'dashboard'
          //     }
          //   },
          //   {
          //     name: 'Application',
          //     path: 'application',
          //     hidden: false,
          //     component: 'system/application/index',
          //     meta: {
          //       title: '应用管理',
          //       icon: 'component'
          //     }
          //   }
          // )
          const accessedRoutes = filterAsyncRouter(arr);
          console.log(
            filterAsyncRouter(arr),
            routes,
            "filterAsyncRouter(routes)"
          );
          accessedRoutes.push({
            path: "*",
            redirect: "/404",
            hidden: true,
          });
          commit("SET_ROUTES", accessedRoutes);
          resolve(accessedRoutes);
        });
      });
    },
  },
};

// 遍历后台传来的路由字符串，转换为组件对象
function filterAsyncRouter(asyncRouterMap) {
  return asyncRouterMap.filter((route) => {
    console.log(route, "route----");
    if (route.component && typeof route.component === "string") {
      // Layout组件特殊处理
      if (route.component === "Layout") {
        route.component = Layout;
      } else {
        console.log(route.component, "route.component");
        route.component = loadView(route.component);
      }
    }
    if (route.children != null && route.children && route.children.length) {
      route.children = filterAsyncRouter(route.children);
    }
    return true;
  });
}

export const loadView = (view) => {
  // 路由懒加载
  console.log(view, "----view");
  return (resolve) => require([`@/views/${view}`], resolve);
};

export default permission;
